#!/bin/bash
if [[ -z "${CTP3_ROOT}" ]]; then
  echo "var CTP3_ROOT not defined, exiting"
  exit
fi
if [[ $1 = "make" ]] ;then
  cd "${CTP3_ROOT}"
  rm -r build ; mkdir build ; cd build
  echo "---------------------------------------------------- cmake3 .."
  cmake3 ..
  echo "---------------------------------------------------- make"
  make
  if [[ $? -ne 0 ]] ;then
    cat - <<-EOF

make failed, binaries (libs) in bin/ (cwrap/lib/) not updated.

EOF
    exit
  fi
fi
# qtutils are directly linked to qtltu, so no need for lib unless other exe uses it
cd "${CTP3_ROOT}"
echo
echo "------------------------------------ copying binaries build/ ---> bin/ "
mkdir -p "${CTP3_ROOT}"/cwrap/lib
cp build/qt/guiLTUall/ctp3-qtltu bin/qtltu
cp build/qt/ltuttc1/ctp3-ltuttc bin/qtltuttc
cp build/qt/qtboard2_1/ctp3-qtboard bin/qtboard
cp build/cwrap/src/boards/ctp3-atbcheck bin/.  
cp build/cwrap/src/boards/ctp3-load bin/.  
cp build/cwrap/src/boards/libctp3boards.so cwrap/lib/
cp build/cwrap/src/common/libctp3common.so cwrap/lib/
cp build/cwrap/src/ttcpon/libctp3ttcpon.so cwrap/lib/

  

