#!/usr/bin/python
# CTP3_ROOT env. variable:
# - if undefined: only ethers file created (i.e. control docker can be started)
# - if defined: all the other files created (files in CTP3_ROOT/... are needed)
# 
# atbx8 special in alice_cf:
# <connection id="atbx8" uri="chtcp-2.0://localhost:10203?target=128.141.175.220:50001" address_table="file://ltu_logicTTC_test_v1.xml"/>
# (minimal.xml in alice_boards)
import os,sys,string
MYBOARDS="myboards.txt"
def pingok(ip):
  resp = (os.system("ping -c 1 -w 1 -n -q %s >/dev/null 2>&1"%(ip)))>>8
  if resp==0: 
    return True
  return False
def dolink(origin):
  #resp = (os.system("ln -s %s . "%origin))>>8
  resp = (os.system("ln -s %s . >/dev/null 2>&1"%origin))>>8
  if resp==0: 
    print "link:", origin
    return True
  #print "ERROR: making link ln -s %s ."%origin 
  return False
def createltucfg(ip,version):
  name="ltu"+ip+".cfg"
  ltucfg=open(name, "w")
  ltucfg.write("# ip address \n")
  ip="IP "+ip
  ltucfg.write(ip)
  ltucfg.write("\n# address file \n")
  ltucfg.write("XML ltu_logic_"+version+ "\n")
  # Defaults to be modified by Detector people
  ltucfg.write("# DETMODE: cru=1 ttc=2 trd=3 cpv=4 \n")
  ltucfg.write("DETMODE 1 \n")
  ltucfg.write("#LL protection \n")
  ltucfg.write("LLprotection 300 \n")
  ltucfg.write("#TTC delay (0-5 values)\n")
  ltucfg.write("TTCdelay 3 \n")
  ltucfg.write("#LVDS delay (0-5 values)\n")
  ltucfg.write("LVDSdelay 3 \n")
  ltucfg.write("#BUSY \n")
  ltucfg.write("enableBUSY 0 \n")
  ltucfg.close()
  print "  %s created."%name
def mymain(version=None):
  #os.chdir(os.getenv("CTP3_CONFIG_DIRECTORY"))
  # TypeError: coercing to Unicode: need string or buffer, NoneType found
  cfgdir=os.getenv("CTP3_CONFIG_DIRECTORY")
  #cfgdir=os.getenv("CTP3_WORK_DIRECTORY")
  print "cfgdir:", cfgdir
  # 
  os.chdir(cfgdir)
  #os.chdir("CF")
  workdir= os.getenv("CTP3_WORK_DIRECTORY")
  if workdir != None:
    if not os.path.exists(workdir):
      os.mkdir(workdir)
      print "\n%s created for .log, .csv,... files"%workdir
  if os.getenv("CTP3_ROOT")!= None:
    if not os.path.islink("minimal.xml"):
      dolink(os.path.join(os.getenv("CTP3_ROOT"),"boards/minimal.xml"))
  if not os.path.exists(MYBOARDS):
    print "ERROR:",MYBOARDS,"missing"
    sys.exit(8)
  if not os.path.isdir("nets"):
    os.mkdir("nets")
    print "\nnets/ created -put your .net file(s) here..."
  myboards = open(MYBOARDS, "r")
  alice_boards = open("alice_boards.xml", "w")
  alice_boards.write('<connections>\n')
  ethers = open("ethers", "w")
  print "\nCreating alice_boards.xml and ethers ..."
  for lin in myboards.readlines():
    pl= string.split(lin)   # boardNumber IP [mac] [ltu_logic]
    if len(lin)==0: continue
    if len(pl)==0: continue
    if lin[0]=="#": continue
    if len(pl)>=4:
      firmware= pl[3]+"_"
    else:
      firmware= "ltu_logic_"
    try:
      bn= int(pl[0])
    except:
      print "Board name instead of the number in line:", lin
      bn= None
    ip= pl[1]   # IP
    #createltucfg(ip,version)    see loop below
    #print lin,pl,":",bn,ip
    #if (str(bon) < "7") or (str(bon) > "31"):
    if bn==None:
      atbname= pl[0]
      if len(pl)<3:
        print("Error: MAC must be given when boardName used instead of boardNumber. Line:",lin)
        continue
      mac= pl[2]
      if mac=="-":
        print("Error: MAC must be given when boardName used instead of boardNumber. Line:",lin)
        continue
      if string.split(mac,":")!= 6:
        print("Error: Wrong MAC address. Line:",lin)
        continue
    elif bn==7 or bn==8:
      atbname= "atbp_%d"%bn
      mac= "08:00:30:00:2a:%2.2x"%bn
    else:
      if (bn < 9) or (bn > 31):
        print "board number not in interval <7..31> in line :", lin
        continue
      atbname= "atb_%d"%bn
      mac= "08:00:30:00:2a:%2.2x"%bn
    alice_boards.write('<connection id="%s" uri="chtcp-2.0://localhost:10203?target=%s:50001" address_table="file://minimal.xml"/>\n'%(atbname,ip))
    ethers.write('%s %s\n'%(mac,ip))
  myboards.close()
  alice_boards.write('</connections>\n')
  alice_boards.close()
  ethers.close()
  myboards.close()
  #
  if version=="check":
    import ibw, findat
  print "\nCreating alice_cf.xml ..."
  myboards = open(MYBOARDS, "r")
  # todo: refuse specific firmware if more boards in MYBOARDS file.
  # Specific firmware update should be allowed only for 1 board!
  alice_cf = open("alice_cf.xml", "w")
  alice_cf.write('<connections>\n')
  for lin in myboards.readlines():
    pl= string.split(lin)
    if len(lin)==0: continue
    if len(pl)==0: continue
    if lin[0]=="#": continue
    try:
      bn= int(pl[0])
    except:
      #print "Bad board number in line:", lin
      bn= None
    ip= pl[1]
    xmlname= None
    if bn==None:
      atbname= pl[0]
      xmlname= pl[3]+".xml"
    elif bn==7 or bn==8:
      atbname= "atbp_%d"%bn
    else:
      atbname= "atb_%d"%bn
    #print atbname,":",lin
    cfgversion=version     # from cmdline expected: e.g. v9
    if version=="check":
      if xmlname==None:
        if pingok(ip):
          if ibw.manager==None:
            ibw.Init("cwd")
          board= ibw.Board(atbname)
          if board.nodExists("ctrl.fwinfo"):
            fwinfo= board.Read("ctrl.fwinfo")
            fwname= fwinfo>>24 ; fwver= (fwinfo>>8) & 0xffff   # without subversion
            xmlname= findat.FindAT(fwname, fwver)
            cfgversion= "v%x"%fwver
            print "%s firmware (checked):"%atbname,xmlname
          else:
            print "The board cannot be checked (ctrl.fwinfo node not available)."
            continue
        else:
          print "Board %s not available, 'cp ethers /etc/ethers' and restart rarpd?"%atbname
          continue
      else:
          print "Board %s: %s in alice_cf file"%(atbname, xmlname)
    else:
      xmlname=firmware+version+".xml"
      print "  Board:%s %s"%(atbname, xmlname)
    # it seems this is not needed
    createltucfg(ip,cfgversion)
    alice_cf.write('<connection id="%s" uri="chtcp-2.0://localhost:10203?target=%s:50001" address_table="file://%s"/>\n'%(atbname,ip, xmlname))
    #print "%s: no action, counting on ipbcfg.tgz"%xmlname
    if not os.path.islink(xmlname):
      dolink(os.path.join(os.getenv("CTP3_ROOT"),"boards",xmlname))
  alice_cf.write('</connections>\n')
  alice_cf.close()
  print """
The generation of CFG/ files finished.
"""

if __name__ == "__main__":
  mbexists= "exists in current directory"
  if len(sys.argv)<=1:
    if not os.path.exists(MYBOARDS):
      mbexists= "does not exist in current directory"
    print """
Input: myboards.txt (%s)
Output files: ethers, alice_cf.xml, alice_boards.xml, ltuXX.XX.XX.XX.cfg

makemycfg.py check           -check board(s) for its firmware
             vc              -use ltu_logic_vc.xml -DO NOT USE THIS when more boards
                                                    with different firmwares 
                                                    present in myboards.txt
             help            -help on the myboards.txt format
"""%mbexists
    sys.exit(8)
  arg1= sys.argv[1]
  if arg1=="help":
    print("""
Input: myboards.txt file with 1 line/board.
       Lines strting with # are comments.

BN IP MAC FW     

where: BN IP: compulsory items, MAC FW: are optional
BN  -boardNumber or boardName -either of two has to be given
      -boardNumber -mac address will be calculated using this number
      -boardname   -in this case also mac address has to be supplied.
IP  -IP address, must be given
MAC -mac address of the board. '-' -> placeholder if boardNumber specified
FW  -one of: ctp_logic ltu_logic_itsmft test_logic
     (default: ltu_logic)

Examples:
16 192.168.1.36

16 192.168.1.36 - test_logic

atb_16 192.168.1.36 08:00:30:00:2a:16 test_logic

""")
    sys.exit(8)
  if (arg1!="check") and (arg1[0]!='v'):
    print "\nBad argument: %s (check or vx_xx expected)"%arg1
    sys.exit(8)
  mymain(arg1)
