#!/usr/bin/python
# 2.9.2016   "l" cmd added, exceptions added
"""
ipbus generic interface:
aboard.py boardname
History:
25.10. inheriting aboard.Session
"""
import sys,string,os  #,traceback
#ipbpath= os.getenv("CTP3_ROOT")
#sys.path.append(os.path.join(ipbpath,"cmdpy/aboard"))
import setsyspath
setsyspath.add("cmdpy/aboard")
#sys.path.append(os.path.join(ipbpath,"cmdpy/ltu"))
import ipbuswrap,i2c, spi, hexdump, colors
import aboard, atbwrap 
import atb.bcmask as bcmask
import atb.fpga as fpga
import atb.cdcscan as cdcscan
from auxfuns import isinargs
import spiatlas

#import pdb
#pdb.set_trace()

def getseltx(cmd):
  seltx=None 
  if cmd=="prbs7":
    seltx= 0
  elif cmd=="prbs23":
    seltx= 1
  elif cmd=="const":
    seltx= 2
  elif cmd=="count":
    seltx= 3
  elif cmd=="onu":
    seltx= 4
  else:
    pass
  return seltx
class Session(aboard.Session):
  ttcpon_mux_docs= {0:"prbs7", 1:"prbs23", 2:"const", 3:"counter", 
    4:"ONU data", 5:"ONU data", 6:"ONU data", 7:"ONU data"}
  PulserBit= 13   # in ctpemu.ctrl 1:edge 0:level
  def __init__(self, board):
    aboard.Session.__init__(self, board, ("ssm", "tdg", "outcnts"))
    #if (board.bname[:4]=="atb_") or (board.bname[:5]=="atbt_") or (board.bname[:5]=="atbp_"):
    #  self.checkDevices()
    #else:   # atbx8 board (PLL will not be checked)
    #  print colors.color("checkDevices() not activeted for atbx8...", "bold")
    self.deverr= None
    self.cdc= None
    #print colors.color("Session init...", "fg_red")
  def printHelp(self, topic=None):
    if topic==None:
      print """
\033[0m\033[01m   DDR4  \033[0m
ssm               Snapshot memory
tdg               Trigger Data Generator
\033[0m\033[01m   Others \033[0m
h front           show Front panel SFPs numbers/type
h i2cttcpon       show help for I2C TTCPON operations (i2c devices accessed over TTCPON fi)
outcnts           show CTPEMU output counters
ttccnts           show TTC counters
leco1             show 64 Link Error COunters (olt1 upstream)
emu               CTP emulator control/status
muxes [h]         read+print tdi_/tdo_/ttcpon_ muxes
fpga              FPGA monitoring
pulser            PLSR input edge/level
cdc               Clock domain crossing (measure, set)
h bcm             show/set BCmask (applied to ph,pp,cal or TOF)
h aboard          show general (aboard) help text
"""
    elif topic=="front":
      print """\033[0m\033[01m Front panel view \033[0m
        SFP numbers    OLTx/gbtx numbers      MGT_X0Y..   FPGA bank
                          (ltu/itsmft)
         2  1          onu/onu  olt9/olt1      09  08     226  226
         4  3           g2/g14   g1/g13        11  10     226  226
         6  5           o6/g2    o5/g1         05  04     225  225
         8  7           o8/g4    o7/g3         07  06     225  225
        10  9           o2/g6    o1/g5         01  00     224  224
        12 11           o4/g8    o3/g7         03  02     224  224
        
      \033[0m\033[01m FMC: \033[0m
       FSFP numbers                   MGT_X0Y..   FPGA bank
                          itsmft
       ? 3  7          gbt12 x         16  14     228  227
       ? 2  6          gbt11 x         17  12     228  227
       ? 1  5          gbt10 x         18  13     228  227
       ? 0  4          gbt9  x         19  15     228  227
"""
    elif topic=="i2cttcpon":
      print """\033[0m\033[01m   I2C TTCPON operations (i2cmainttc slave, i2cttcmux has to be set to: ipbus/11 ) \033[0m
i2cwr addr memloc val   -write 1 byte
i2crd1 addr memloc      -read 1 byte
i2crd2 addr memloc      -read 2 bytes
i2ctmux XXX       set i2cttcmain.mux. XXX: olt1..olt9 onu ipbus
                                      XXX: olt1 onu ipbus   for ltu_logic_itsmft
"""
    elif topic=="bcm":
      print """\033[0m\033[01m    BC masks \033[0m
bcm TOF enable    -enable the mask: starts TOF trigger generation even when ctpemu stopped
        disable   
        show      -show (read from a board, default)
        3L2H3559L -new definition (bcmasks.data will be updated in a board)
        3 4       -the same, i.e. only two BCs with BCids 3 and 4 choosen (High)
"""
    else:
      aboard.Session.printHelp(self, topic)
  def printttcponmux(self):
    for olti in range(1,10):   # olt1..9 for ltu_logic
      ttcpon_mux= self.board.Read("ttcponolt_u%d.uregs"%olti, 2) & 7
      print "ttcponmux %d: 0x%x: %s"%(olti, ttcpon_mux, self.ttcpon_mux_docs[ttcpon_mux])
      if not self.board.isfiwa((self.board.FW_LTU_LOGIC, self.board.FW_CTP_LOGIC)):
        break
  #def checkDevices(self):
  #  self.cdc= None
  #  print colors.color("checkDevices: checking devices on atb_/atbp_...", "bold")
  def execcmdl_u(self, cmd):
    if (cmd[0] == 'ssm')or (cmd[0] == 'tdg') or (cmd[0]== 'emu') or\
      (cmd[0]== 'outcnts') or (cmd[0]== 'leco1') or (cmd[0]== 'ttccnts') or\
      (cmd[0]== 'fpga') or (cmd[0]== 'tdomux') or (cmd[0]== 'tdimux'):
      if self.board.atbdevs.has_key(cmd[0]):
        self.board.atbdevs[cmd[0]].excmd(cmd)
      else:  
        print "cmd/device %s not availabe"%cmd[0]
    elif cmd[0] == 'bcm':
      # bcm tof show 0
      mskid= 3   # tof
      action= "show" ; ok1= True
      if len(cmd)>1:
        if cmd[1] in bcmask.symname:
          mskid= bcmask.symname.index(cmd[1])
        else:
          print "Bad mask, expected one of:",bcmask.symname
          ok1= False
          action="err"
      if ok1 and len(cmd)>2:
        action= cmd[2]
      if action=="show":
        bcm= bcmask.BCmask(self.board, mskid)   # board-> bcm
        bcm.prt()
      elif action=="err":
        pass
      elif "enable".find(action)==0:
        self.board.SetBit("ctpemu.BCmask_ena", mskid)
      elif "disable".find(action)==0:
        self.board.ResetBit("ctpemu.BCmask_ena", mskid)
      else:   # new mask: "4H3560L" or "0 1 2 3000"
        bcm= bcmask.BCmask(self.board, mskid)
        bcmdef= string.join(cmd[2:])
        bcm.updatehw(bcmdef)   # definition-> bcm -> hardware
    elif cmd[0] == 'pulser':
      ctrlbits= self.board.Read("ctpemu.ctrl")
      pulserbit= (ctrlbits>>self.PulserBit) & 1
      if len(cmd)>1:
        if 'edge'.find(cmd[1])==0:
          pulsbitsh= 1<<self.PulserBit
          ctrlbits= ctrlbits | pulsbitsh
          self.board.Write("ctrl.ctrl", ctrlbits)
          pulserbit= 1
        elif 'level'.find(cmd[1])==0:
          pulsbitsh= ~(1<<self.PulserBit)
          ctrlbits= ctrlbits & pulsbitsh
          self.board.Write("ctrl.ctrl", ctrlbits)
          pulserbit= 0
        else:
          print "Error: pulser or edge expected"
      if pulserbit==1:
        pulstatus= "edge"
      else:
        pulstatus= "level"
      print "Pulser input detection: %s"%pulstatus
    # i2cttcpon operations:
    elif cmd[0]=='cdc':
      if self.cdc==None:
        self.cdc= cdcscan.CDC(self.board, self.board.atbdevs['tdomux'])
      #print "cdc phase now: ", self.cdc.phase
      if len(cmd)>2:
        if cmd[1]=='g':
          phase= self.cdc.getphase()
          print "cdc phase: %d"%phase
        elif cmd[1]=="set":
          self.cdc.setphase(eval(cmd[2]))
          print "CDC phase %s set."%cmd[2]
        elif cmd[1]=="m":
          self.cdc.measure(eval(cmd[2]))
        else:
          self.cdc.prtHelp()
      elif len(cmd)>1:
        if cmd[1]=="r":
          self.cdc.reset()
          print "reset done."
        elif cmd[1]=='g':
          phase= self.cdc.getphase()
          print "cdc phase: %d"%phase
        else:
          self.cdc.prtHelp()
      else:
        self.cdc.prtHelp()
    elif (cmd[0] == 'i2cwr') or (cmd[0] == 'i2crd1') or (cmd[0] == 'i2crd2'):
      addr= eval(cmd[1])
      mem= eval(cmd[2])
      if len(cmd)==4: val= eval(cmd[3])
      if (cmd[0] == 'i2cwr'):
        val= self.i2cs[self.i2cinuse].i2cwr(addr, mem, val)
      elif (cmd[0] == 'i2crd1'):
        val= self.i2cs[self.i2cinuse].i2crd1(addr, mem)
      elif (cmd[0] == 'i2crd2'):
        val= self.i2cs[self.i2cinuse].i2crd2(addr, mem)
    elif cmd[0] == 'muxes':
      if len(cmd)>1:
        print """muxes:
tdimux:     input mux (ONU data): 8:ssm 4:det3 2:det2 1:det1
tdomux:     output mux (output data sent to OLTx/GBTx)
            'tdomux help' for more info
ttcponmux:  ttcpon OLTcore firmware output (3 low bits of ttcponolt_uX.uregs[2])
            'ttcponmux help' for more info
i2ctmux:    connecting EP/I2C firmware(controlling i2cmainttc devices) to 
            ttcpon-core resp. ipbus in boards's fpga.
            See i2cmainttc.mux reg in top node of the .xml file. Valid values:
            -ltu_logic:        1..9: olt1..9, 10:onu or 11:ipbus
            -ltu_itsmft_logic: 1: olt1, 10:onu or 11:ipbus
            'i2ctmux help' for more nfo
"""
      else:
        # let's print muxes in natural order: TDI TTCPON TDO
        if self.board.nodExists("ctrl.tdi_mux"):
          tdi_mux= self.board.Read("ctrl.tdi_mux")   # trigger data input
          print "tdimux: 0x%x"%tdi_mux
        else:
          print "tdimux: not present (ctrl.tdimux not available in .xml file)"
        #
        self.printttcponmux()
        #
        # tdo mux: only for olt1 (emu data cannot be connected in fi <=9_05) to olt2,3,...
        self.board.atbdevs["tdomux"].prtStatus()
    elif cmd[0] == 'ttcponmux':
      if len(cmd)== 2: 
        if (cmd[1]=="help") or (cmd[1]=="h"):
          print """
ttcponmux N [prbs7 | prbs23 | const | count | onu ]
          where N: olt number (1..9 for ltu_logic, 1: for itsfmt_logic
"""
      elif len(cmd)== 3: 
          olti= '1' ; maxolti= '1'
          if self.board.isfiwa((self.board.FW_LTU_LOGIC, self.board.FW_CTP_LOGIC)):
            maxolti='9'
          if (cmd[1] >= '1') and (cmd[1]<=maxolti):
            olti= int(cmd[1])
            sel= getseltx(cmd[2])
            if sel!=None:
              self.board.Write("ttcponolt_u%d.uregs"%olti, sel, 2)
              print "ttcponolt_u%d.uregs[2] <- %d"%(olti, sel)
          else:
            print "Bad olt number: %s, max.:%d"%(cmd[1],maxolti)
      else:
        self.printttcponmux()
    elif cmd[0] == 'i2ctmux':
      if self.board.isfiwa((self.board.FW_LTU_LOGIC, self.board.FW_CTP_LOGIC)):
        itsfmt= False
      else:
        itsfmt= True
      if len(cmd)== 2:
        #self.i2cs[self.i2cinuse].seti2cttcmux(cmd[1], itsmft)
        self.i2cg.seti2cttcmux(cmd[1], itsfmt)
        print "Ok, set."
      else:
        muxv= self.board.Read("i2cmainttc.mux")
        print "i2cmainttcmux:",muxv, "(1..9: olt1..9, 10:onu, 11:ipbus)"
    else:
      return False
    return True

def main():
  if len(sys.argv) < 2 or (len(sys.argv)==2 and sys.argv[1]=="help"):
    print """
Usage:
ltuctl boardname [all] [pllin0 | pllin1 | pllnocheck]

also alias atb, i.e.: atb boardname or atb N

all:        all front panel SFPs will be checked 
            default: check only olt1+onu+ipbus SFPs

pllin0:       check/load PLL IN0 config (global)
pllin1:       check/load PLL IN1 config (stdalone)
pllnocheck:   do not check PLL config
pllcheckonly: only check what is loaded (do not reload PLL)  -default 
""" #available boards (%s): """%ipbuswrap.ConnectionFN
    cmd=os.path.join(os.getenv('CTP3_ROOT'),"pywrap","checkboards.py")
    from subprocess import call 
    call([cmd, "all"])
    sys.exit()
    #import saxipbus
    #saxipbus.printConnectionFile(ipbuswrap.ConnectionFN, True)
    #print "\nNew way using %s + ctrl.fwinfo:"%ipbuswrap.AliceBoards
    #saxipbus.printConnectionFile(ipbuswrap.AliceBoards)
    #sys.exit()
  print "CTP3_CONFIG_DIRECTORY:", os.getenv("CTP3_CONFIG_DIRECTORY")
  os.chdir(os.getenv('CTP3_WORK_DIRECTORY'))
  print "working directory: "+os.getenv('CTP3_WORK_DIRECTORY')
  phbname= sys.argv[1]
  if phbname.isdigit():
    if (phbname=='7') or (phbname=='8'):
      bas= "atbp_"
    else:
      bas= "atb_"
    phbname= bas+phbname
    #print "LTU board:", phbname
  if ipbuswrap.Init(phbname)==None:
    print "Problem with ipbus Init()."
    return
  #board= ipbuswrap.Board(phbname)
  board= atbwrap.OpenATBoard(phbname)
  singles=""
  for ix in range(len(board.idslist)):
    node= board.nodlist[board.idslist[ix]]
    mode= str(node.getMode())
    singname= board.idslist[ix]
    if mode=="SINGLE":
      singles= singles+singname+" "
    else:
      if (mode=="INCREMENTAL"):
        pass
  #print "\nSingle registers: %s"%singles
  session= Session(board)
  if session.deverr!=None: return
  #session.printHelp()
  session.execcmdl()

if __name__ == "__main__":
  main()


