#!/bin/bash
PROJECT_DIR="$(dirname $(dirname $(readlink -m "${BASH_SOURCE[0]}")))"
export CTP3_ROOT=$PROJECT_DIR   # software location
export CTP3_CONFIG_DIRECTORY=${CTP3_CONFIG_DIRECTORY-"$HOME/CFG"}   # config location
export CTP3_ETHER_FILE=${CTP3_ETHER_FILE-"/etc/ethers"}
export CTP3_WORK_DIRECTORY=${CTP3_WORK_DIRECTORY-"$HOME/WORK"}

[ -f $CTP3_ETHER_FILE ] || unset CTP3_ETHER_FILE

if [ -z $container ] ;then
  # not docker environment
  [[ ":$PATH:" == *":$CTP3_ROOT/scripts/bin:"* ]] || export PATH=$CTP3_ROOT/scripts/bin:$PATH
  [[ ":$PATH:" == *":$CTP3_ROOT/bin:"* ]] || export PATH=$CTP3_ROOT/bin:$PATH
else
  # docker environment
  [[ ":$PATH:" == *":$CTP3_ROOT/bin:"* ]] || export PATH=$CTP3_ROOT/bin:$PATH
fi
[[ ":$LD_LIBRARY_PATH:" == *":/opt/cactus/lib:"* ]] || export LD_LIBRARY_PATH=/opt/cactus/lib:$LD_LIBRARY_PATH
[[ ":$LD_LIBRARY_PATH:" == *":$CTP3_ROOT/cwrap/lib:"* ]] || export LD_LIBRARY_PATH=$CTP3_ROOT/cwrap/lib:$LD_LIBRARY_PATH
[[ ":$LD_LIBRARY_PATH:" == *":$CTP3_ROOT/lib64:"* ]] || export LD_LIBRARY_PATH=$CTP3_ROOT/lib64:$LD_LIBRARY_PATH
#[[ ":$PYTHONPATH:" == *":$CTP3_ROOT/pywrap:"* ]] || export PYTHONPATH=$PYTHONPATH:$CTP3_ROOT/pywrap:$CTP3_ROOT/ublaze/rev_0_1_0
[[ ":$PYTHONPATH:" == *":$CTP3_ROOT/pywrap:"* ]] || export PYTHONPATH=$PYTHONPATH:$CTP3_ROOT/pywrap
source $CTP3_ROOT/etc/profile.d/aliases.sh

# better (i.e. not destroying existing PYTHONPATH): if pywarp: remove pywrap from PYTHONPATH
#export PYTHONPATH=$PYTHONPATH:$CTP3_ROOT/pywrap
# following only for MCH:
#read -a vals <<< $(python -V 2>&1)
#pyver=${vals[1]:0:1}
#if [[ "$pyver" = "2" ]] ;then
#  echo "this.sh: adding site-packages for python $pyver..."
#  [[ ":$PYTHONPATH:" == *"site-packages:"*  ]] || export PYTHONPATH=$PYTHONPATH:/usr/lib/python2.7/site-packages
#fi
