#!/usr/bin/python
class TDIOmux:
  def __init__(self, board):
    self.board= board
  def setmux(self, inpi):
    val= self.board.Read("ctrl."+self.muxs)&0xfffffff0
    val= val | (inpi&0xf)
    self.board.Write("ctrl."+self.muxs, val)
  def getmux(self):
    #fwinfo= self.board.Read("ctrl.fwinfo")
    #if ((((fwinfo>>8) & 0xffff) == 9) and ((fwinfo & 0xff) <= 6)) or\
    #  (((fwinfo>>8) & 0xffff) < 9):
    #  val= self.board.Read("ttcponolt_u1.uregs", 128)&7
    #else:
    #  val= self.board.Read("ctrl.tdo_mux")&7   # from fi 9_07
    val= self.board.Read("ctrl."+self.muxs)&0xf   # from fi 9_07
    return val
  def setcmd(self, inpsi):
    if type(inpsi) is int:
      if self.mux_docsbrief.has_key(inpsi):
        self.setmux(inpsi)
      else:
        print "%s: bad setting:%d, not set"%(self.mux_name,inpsi)
    elif type(inpsi) is str:
      if (inpsi>='0') and (inpsi<='4') and (inpsi!='3'):
        self.setmux(int(inpsi))
      #elif inpsi in self.mux_docsbrief.values():
      else:
        found= False
        for ki in self.mux_docsbrief.keys():
          #print "dbg tdomux:",ki,self.mux_docsbrief[ki]
          if self.mux_docsbrief[ki]==inpsi:
            self.setmux(ki)
            found= True ; break
        if not found:
          print "%s: bad setting:"%self.mux_name,inpsi,"not set"
    else:
      print "%s: bad setting:"%self.mux_name,inpsi,"not set"
  def prtStatus(self):
    val= self.getmux()
    print "%s: %d = %s"%(self.mux_name,val,self.mux_docs[val])
  def prtHelp(self):
    muxcmd= self.mux_name.lower()
    print """
%s      -show current setting
%s %s   -set 
"""%(muxcmd, muxcmd," | ".join(self.mux_docsbrief.values()))
    self.prtSpecHelp()
  def prtSpecHelp(self):
    pass
  def excmd(self, cmd):
    if len(cmd)==2:
      if cmd[1] in self.mux_docsbrief.values():
        self.setcmd(cmd[1])
        val= self.getmux()
        print "%s: %d = %s"%(self.mux_name,val,self.mux_docs[val])
      else:
        self.prtHelp()
    elif len(cmd)==1:
      self.prtStatus()
    else:
      self.prtHelp()
class TDOmux(TDIOmux):
  mux_name= "TDOmux"
  muxs= "tdo_mux"   # reference to .xml
  mux_docsbrief= {0:"ttcpon", 1:"emu", 2:"emutrd", 4:"tdg", 8:"onu"}
  mux_docs= {0:"ttcpon firmware", 1:"CTP emulator", 2:"CTP emulator for TRD/CPV",
    4:"TDG (Trigger Data generator)", 8:"ONU data"}
  def prtSpecHelp(self):
    print """
ttcpon: always OLT1 connected, even in case of empty OLT1 slot.
"""
class TDImux(TDIOmux):
  mux_name= "TDImux"
  muxs= "tdi_mux"   # reference to .xml
  mux_docsbrief= {0:"onu", 1:"det1", 2:"det2", 4:"det3", 8:"SSM"}
  mux_docs= {0:"raw ONU data", 1:"DET1 data", 2:"DET2 data", 4:"",
    8:"DET3 data"}
class CTPTDOmux:
  mux_name= "CTPTDOmux"
  muxs= "tdo_mux"   # reference to .xml
  def __init__(self, board):
    self.board= board
    self.muxcmd= self.mux_name.lower()
  def setmux(self, valall):
    self.board.Write("ctrl."+self.muxs, valall)
  def setcmd(self, inpstr):
    """ tttccp -set TDG for olt1..3 and CTP for olt4..5 and TTCPON for olt6
"""
    #val= self.board.Read("ctrl."+self.muxs)&0xffffff
    if len(inpstr)!=6:
      self.prtHelp()
      valall= None
    else:
      valall= 0
      for ix in range(6):
        oltn= ix+1
        if inpstr[ix]=='t':  # tdg
          val= 2
        elif inpstr[ix]=='c':  # ctp
          val= 1
        elif inpstr[ix]=='p':  # ttcpon
          val= 0
        else:
          prtHelp()
          return None
        valall= valall | (val<<(ix*4))
      self.setmux(valall)
    return valall
  def getmux(self):
    valall= self.board.Read("ctrl."+self.muxs)&0xffffff
    return valall
  def val2str(self, valall):
    outstr=""
    for ix in range(6):
      val= (valall >> (ix*4)) & 0xf
      if val==2:
        outstr= outstr + 't'
      elif val==1:
        outstr= outstr + 'c'
      elif val==0:
        outstr= outstr +'p'
      else:
        outstr= outstr + "%x"%val
    return outstr
  def prtStatus(self):
    val= self.getmux()
    valstr= self.val2str(val)
    print "%s: 0x%x = %s"%(self.mux_name, val, valstr)
  def prtHelp(self):
    print """
%s          -show current setting
%s xxxxxx   -set mux for all OLTs (1..6). where x is t|c|p
             t:TDG   c:CTP   p:TTCPON
"""%(self.muxcmd, self.muxcmd)
  def excmd(self, cmd):
    if len(cmd)==2:
      if cmd[1]=="test":
        val=0x012345
        valstr= self.val2str(val)
        print "%s TEST: 0x%x = %s"%(self.muxcmd,val, valstr)
      else:
        self.setcmd(cmd[1])
        val= self.getmux()
        valstr= self.val2str(val)
        print "%s: 0x%x = %s"%(self.muxcmd,val, valstr)
    elif len(cmd)==1:
      self.prtStatus()
    else:
      self.prtHelp()
