#!/usr/bin/env python
from __future__ import print_function
import sys,os,string,colors
def printError(incolor, msg=""):
  print(colors.color(incolor, "fg_red"), msg)

def find1rand(N):
  primes= (3,5,7,11,13,17,19,23,29,31,37,41,43,47,53,59,61,67,71,
    73,79,83,89,97,101,103,107,109,113,127,131,137,139,149,151,157,163,167,173,
    179,181,191,193,197,199,211,223,227,229,233,239,241,251,257)
  if N>primes[12]:
    nfix=12
  elif N<4:
    return 1 
  else: nfix= 0
  nfirst= primes[nfix]
  while (N % nfirst) == 0: 
    nfix=nfix+1
    nfirst= primes[nfix]
    if nfix>=len(primes):
      print("cannot find right number")
      return None
  print("N:%d nfirst:%d"%(N, nfirst))
  return nfirst
def cdworkdir():
  wkdir= os.getenv('CTP3_WORK_DIRECTORY')
  if not wkdir:
    print("Env. variable CTP3_WORK_DIRECTORY not set.")
    sys.exit(8)
  if not os.path.isdir(wkdir):
    print("Creating work directory:",wkdir,"...")
    os.mkdir(wkdir)
  os.chdir(os.getenv('CTP3_WORK_DIRECTORY'))
def getarg1():
  if len(sys.argv) < 2: return ""
  p1= string.split(sys.argv[1],'.')
  if (len(p1)==2) and (p1[1]=="net"):
    return p1[0]
  else:
    return sys.argv[1]
def isinargs(myid):
  for ida in sys.argv[2:]:   # start search after 1st arg (1st arg: name.net)
    #print "isinargs:", ida
    if ida==myid: return True
  return False
def fromms(newval):
  """return: None if syntax error, else: # of BCs between 2 triggers
newval:
string representing integer number (32bits) giving the number
of BCs (25ns) between 2 triggers. 

Examples of newval string:
0          -> BC rate (40MHz)
1          -> 40/2 MHz rate
4000       -> generate 1 START signal per 100 micsecs
40000      -> generate 1000 START signals per second
40000000   -> generate 1 START signal per second
0x7fffffff -> generate 1 START signal per 53.7 seconds
n          -> generate 1 START signal per (n+1)/BC micsecs, where
              BC is BC rate (40*10**6)

or use: s  (seconds)  ms  (miliseconds)  us  (micsecroseconds)   for period or
        hz (Hertz)    khz (Kilohertz)    mhz (Megahertz)         for rate:
3s    -   3 seconds
10ms  -  10 miliseconds period
300us - 300 microseconds period
3khz  -   3 kilohertz rate
1mhz  -   1 megahertz rate

  """
  bcfrekv=40.079
  try:
    if string.lower(newval[-1])=='s':   # period given in s,ms, or us
      #  n= period*BC-1  n->VMEwrite, period[micsecs], BC[MHz]
      retval= newval[:-1]
      mult=1000000
      if string.lower(retval[-1])=='m':     # milisecs
        retval= retval[:-1]
        mult=1000
      elif string.lower(retval[-1])=='u':   # micsecs
        retval= retval[:-1]
        mult=1
      retval=str(int(float(retval)*mult*bcfrekv-1))
    elif string.lower(newval[-2:])=='hz':   # rate given: hz khz or mhz
      retval= newval[:-2]
      mult=1000000
      if string.lower(retval[-1])=='m':     # mhz
        retval= retval[:-1]
        mult=1
      elif string.lower(retval[-1])=='k':   # khz
        retval= retval[:-1]
        mult=1000
      retval=str(int(bcfrekv*mult/float(retval)-1))
    elif (len(newval)>2) and (newval[:2]=='0x'):  # direct hexa
      retval=newval
    else:     # n given directly as int
      intrep= int(newval)
      retval= str(newval)
  except:
    retval=None
  #print "fromms:",oldval,type(oldval), newval,type(newval),retval
  return retval

def main():
  if len(sys.argv) < 2:
    print("""
./auxfuns.py rate [N]
python auxfuns.py 45.4khz 86*47*53*59
""")
    return
  rate= sys.argv[1]
  bcs= fromms(rate)
  print("rate {0}: {1} BCs between 2 triggers".format(rate, bcs))
  if len(sys.argv) > 2:
    N= eval(sys.argv[2])
    nfirst= find1rand(N)
    print("Checking, should give %d items in a..."%N)
    n= nfirst
    a=[]
    while True:
      a.append(n)
      n=(n+nfirst)%N
      if n==nfirst: break
    #a.sort()
    print(len(a), a)

if __name__ == "__main__":
  main()
