#!/usr/bin/python
import sys
dumptype= 'x'   # x d xd
linlen=10   # words in 1 line
def hd_dump(va, fr, ixmax, frshift=0, dumptyp=None, onlyvalid=None, stdprint="stdout"):
  """ va[] -values (array of unsigned ints)
  fr      -from
  ixmax   -to
  frshift -addresses (shown on the left) will be shifted, i.e.
           instead of ix: ix+10: ...
                      ix+frshift: ix+10+frshift: ...
  dumptyp -x d xd dpon
  onlyvalid         v: only Valid data i.e.: (Valid bit on) or (TT !=0)
               0xhexa: only if at least 1 of hexa is on in TriggerType
  """
  global linlen
  rcout= ""
  if dumptyp==None: dumptyp= dumptype
  if dumptyp=='dpon': linlen= 4
  if ixmax >= len(va): ixmax= len(va)-1
  onlyvalidpat=None
  if onlyvalid!=None:
    if onlyvalid != 'v':
      if (len(onlyvalid)>2) and (onlyvalid[:2]=="0x"):
        onlyvalidpat= eval(onlyvalid)
      else:
        print "hs_dump: incorret pattern (0x...  or v expected)"
        onlyvalidpat=None
  #linlen=8 
  frstart= (fr/linlen)*linlen
  afmt= "%%%dd:"%len(str(ixmax+frshift))
  afmt2= ' '*len(str(ixmax+frshift))+' '
  #print afmt, "afmt2:",afmt2, "fr:",fr,"frshift:",frshift
  # find maximal length of x/d data
  mxdl=0; mxxl= 0
  for ix in range(frstart, ixmax):
    lng= len(hex(va[ix]))
    if mxxl<lng: mxxl= lng
    lng= len(str(va[ix]))
    if mxdl<lng: mxdl= lng
  maxx= mxxl
  if maxx < mxdl: maxx= mxdl
  #dfmt_x= " %%%dx"%(mxxl-2+2)   # do not count 0x
  #dfmt_d= " %%%dd"%mxdl
  dfmt_x= " %%%dx"%(maxx-2+2)   # do not count 0x
  dfmt_d= " %%%dd"%maxx
  #print "dfmt_:", dfmt_x, dfmt_d, frstart
  if dumptyp=='dpon':
    if stdprint=="stdout":
      print afmt2+"V H WC ORBIT   BCID TTYPE"
    else:
      rcout= afmt2+"V H WC ORBIT   BCID TTYPE\n"
  while True:
    if frstart>ixmax: break
    line = afmt%(frstart+frshift)
    lined = afmt2
    ignore= False
    for ix in range(linlen):
      if (frstart+ix)>ixmax: break
      wval= va[frstart+ix]
      if dumptyp=='x':
        #line= line + " %8x"%a[frstart+ix]
        line= line + dfmt_x%va[frstart+ix]
      elif dumptyp=='d':
        #line= line + " %10d"%a[frstart+ix]
        line= line + dfmt_d%va[frstart+ix]
      elif dumptyp=='xd':
        #line= line + "  "+" %8x"%a[frstart+ix]
        line= line + dfmt_x%va[frstart+ix]
        #lined= lined + " %10d"%a[frstart+ix]
        lined= lined + dfmt_d%va[frstart+ix]
      elif dumptyp=='dpon':
        # 4 words (128 bits instead of 200 bits) caught only in SSM: 
        #                orbit       bcid  ttype
        # whV.....   ....oooo   oooo.iii   tttttttt
        # 1514         10 9 8      6 5 4    3 2 1 0  pon byte
        #   80431c   9da32cd7   23180b73         40
        #     431c   9da22cd7   23180b72          0
        #
        # w: Word count (7 bits)
        # h: Header flag
        # V: Valid bit
        if ix==0:   # whV..... w:0xfe000000  h:0x1000000 V:0x800000
          if (wval & 0x800000)== 0: 
            validbit= False    # still may change with T
            line= line + "."
          else:
            validbit= True    # Valid word (128 bits)
            line= line + "V"
          wc= (wval>>25) & 0x7f        # Word count
          if (wval & 0x1000000)== 0:   # Header flag
            line= line+" H%3d"%wc
          else:
            line= line+" .%3d"%wc
        elif ix==1:   # ....oooo       # Orbit upper bits
          orbit= ((wval&0xffff)<<16)
        elif ix==2:   # oooo.iii       # Orbit lower bits + bcid
          orbit= orbit | ( wval>>16)
          bcid=  wval & 0xfff
          line= line+" %8x %3x"%(orbit, bcid)
        elif ix==3:   # tttttttt       # Trigger Type
          if onlyvalid=='v':
            if (validbit==False) and (wval==0): ignore= True
          elif onlyvalidpat!=None:      # chase a TT pattern
            # check '1' for at leaast 1 bit
            if (wval & onlyvalidpat) == 0: ignore= True
          line= line + " %8x"%wval
      else:
        # x default
        #line= line + " %8x"%a[frstart+ix]
        line= line + dfmt_x%va[frstart+ix]
    if not ignore: 
      if stdprint=="stdout":
        print line
        if dumptyp=='xd': print lined
      else:
        rcout= rcout+line
        if dumptyp=='xd': rcout= rcout+lined
        rcout= rcout+"\n"
    frstart= frstart + linlen
  return rcout[:-1]   # not last new line
def main():
  global dumptype
  #with open('hexdump.py','rb') as f:
  #  hex_content = f.read().encode('hex')
  #a= str([10,20])
  #hex_content = a.encode('hex')
  #print a,hex_content
  a=[]
  for ix in range(10000):
    a.append(ix)
  if len(sys.argv)<2: dumptype='x'
  else: dumptype= sys.argv[1]
  hd_dump(a, 34, 1055)
if __name__ == '__main__':
    main()
