#!/usr/bin/env python
import logging
# logging levels:
logger= None
# https://docs.python.org/2/howto/logging.html
# levels:
# critical 50
# error 40
# warning 30
# info 20
# debug 10    -i.e. DETAILED
# notset 0
def ilogger(fn, logname="", dbglog=None):
  global logger
  formatter = logging.Formatter(
    '%(asctime)s %(name)s %(levelname)s: %(message)s',
    datefmt='%d-%m-%y %H:%M:%S')
  # Logger definition:
  # create logger with 'ttc_pon' application
  #logname= "ttc_pon" should be with ttcpon sw, see driver_comm.py self.logger...
  logger = logging.getLogger(logname)
  if dbglog == None:
    dbglog= "info"
    level=logging.INFO
    #dbglog= "warning"   # fewer messages in .log file by default
    #level=logging.WARNING
  elif dbglog == "detailed":
    level=logging.DEBUG
  elif dbglog == "warning":
    level=logging.WARNING
  else:
    level=logging.INFO
  #print("ilogger: ", dbglog, "level set: ", level)
  logger.setLevel(level)   # DEBUG: more detailed
  # create file handler which logs even debug messages
  fh = logging.FileHandler(fn)
  #fh.setLevel(logging.DEBUG) use parent level
  fh.setFormatter(formatter)
  logger.addHandler(fh)
  # create console handler with a higher log level
  ch = logging.StreamHandler()
  ch.setLevel(logging.ERROR)   # only ERRORS to console
  ch.setFormatter(formatter)
  logger.addHandler(ch)
  return logger
def myapp():
  logger.info("myapp info")
  logger.debug("myapp debug")
  logger.warning("myapp warning")
  err="err message"
  logger.error("myapp error %s",err)
  logger.critical("myapp critical")

def main():
  import sys
  #import ttcpon.ttcponnet
  global logger
  if len(sys.argv)<2:
    print("""
ilogger.py fname [logid [level]]
logid: "" (def)
level: info (def) detailed warning
""")
    sys.exit(8)
  fname= sys.argv[1]   #.split('.')[0]
  logid= sys.argv[2]
  #logging.basicConfig()
  logger= ilogger(fname+".log", logid)   # logname="aaa", dbglog='detailed')
  #tpn= ttcpon.ttcponnet.TtcPonNet(logger, netname)
  myapp()
if __name__ == '__main__':
  main()
