#!/usr/bin/env python
# !/usr/bin/python
"""
2.9.2016   "l" cmd added, exceptions added
"""
import saxipbus,findat
import uhal,sys,os,string,time,types
manager= None
CTP3_ROOT= os.getenv("CTP3_ROOT")
#ConnectionFN= os.path.join(os.getenv("CTP3_CONFIG_DIRECTORY"),"connection_file.xml")
ConnectionFN= os.path.join(os.getenv("CTP3_CONFIG_DIRECTORY"),"alice_cf.xml")
AliceBoards= os.path.join(os.getenv("CTP3_CONFIG_DIRECTORY"),"alice_boards.xml")
AllBoards= {}
class Board:
  """ Usage:
  import ipbuswrap
  ipbuswrap.Init("path to connection_file") 
  # instantiate Board class, discouraged:
  #board= ipbuswrap.Board("boardname")   # one of names in a connection file
  # following preferred:
  board= ipbuswrap.OpenBoard("boardname") -only one instance of Board kept
  i.e. in ttcpon_core/driver_comm.py: one ipbus-connection
     for all olts+onu on 1 atb board
  
  # single register operations:
  readval= board.Read("regname")   # one of "SINGLE" names in
  board.Write("regname",value)     # board's .xml file
  # block operations, i.e. read/write array of values:
  values= board.ReadBlock("blockname",N,offset)   # mode="block"
  board.WriteBlock(blockname,values, offset)

  """
  FW_CTP_LOGIC= 10
  FW_LTU_LOGIC= 11
  FW_LTU_ITSMFT_LOGIC= 12
  FW_LTU= (11,12)
  FW_TEST_LOGIC= (5,6,7,8,9)
  FW_TTCIT_LOGIC= 13
  def __init__(self, boardname):
    self.bname= boardname
    self.idslist=[]   # sorted node-names [node1, node1.id1, node1.id2, node2, node2.id1,...]
    self.nodlist={}   # key-access to each node nodes+leaves
    self.tn_inuse=""  # to be used ONLY in interactive apps (i.e. shloud be "" otherwise)
    self.level= 0
    self.dispisin= True
    self.hw = manager.getDevice(boardname)
    #print "Board hw:", self.hw     -seems it returns board name (if .xml found)
    self.idslist= self.hw.getNodes(".*")   # all nodes (id id.id ...)
    self.idslist.sort()
    # ['ctrl_reg', 'ctrl_reg.id', 'ctrl_reg.rst', 'pram', 'pram.addr', 'pram.data', 'ram', 'reg']
    #print "idslist:", self.idslist
    ixnod=0
    while ixnod < len(self.idslist):
      # ixnod:  points now to item to be processed
      ixnod= self.scannode("", ixnod)
    #print "nodlist:", self.nodlist
    self.i2cgmuxes= {"SFP1": ((0x76,0, 0x74,1<<2)), "SFP2": ((0x76,0, 0x74,1<<3)),\
"SFP3": ((0x76,0, 0x74,1<<4)), "SFP4": ((0x76,0, 0x74,1<<5)),\
"SFP5": ((0x76,0, 0x74,1<<6)), "SFP6": ((0x76,0, 0x74,1<<7)),\
"SFP7": ((0x74,0, 0x76,1<<2)), "SFP8": ((0x74,0, 0x76,1<<3)),\
"SFP9": ((0x74,0, 0x76,1<<4)), "SFP10": ((0x74,0, 0x76,1<<5)),\
"SFP11": ((0x74,0, 0x76,1<<6)), "SFP12": ((0x74,0, 0x76,1<<7)) }
    if self.nodExists("ctrl", True):
      if self.bname=="atb_3":    # zenaj debug
        #self.fwinfo= 0xb000e01
        self.Write("ctrl.fwinfo",0xb000e01);
      self.fwinfo= self.Read("ctrl.fwinfo")
      if (self.fwinfo>>24) == self.FW_LTU_ITSMFT_LOGIC:
        self.fwsfps= {"olt1":"SFP1","onu":"SFP2",\
"gbt1":"SFP5","gbt2":"SFP6","gbt3":"SFP7","gbt4":"SFP8",\
"gbt5":"SFP9","gbt6":"SFP10","gbt7":"SFP11","gbt8":"SFP12",\
"gbt13":"SFP3","gbt14":"SFP4" }      
#"gbt13":"SFP3"}   # did work with vf_01 ,"gbt14":"SFP4" in s/g
      elif ((self.fwinfo>>24) == self.FW_LTU_LOGIC) or\
        ((self.fwinfo>>24) == self.FW_CTP_LOGIC):
        self.fwsfps= {"olt1":"SFP9","onu":"SFP2",\
"gbt1":"SFP3", "gbt2":"SFP4",\
"olt2":"SFP10", "olt3":"SFP11", "olt4":"SFP12", "olt5":"SFP5",
"olt6":"SFP6", "olt7":"SFP7", "olt8":"SFP8", "olt9":"SFP1"}
      else:
        #self.fwsfps= {}  let's use itsmft assignment for test_logic...
        self.fwsfps= {"olt1":"SFP1","onu":"SFP2",\
"gbt1":"SFP5","gbt2":"SFP6","gbt3":"SFP7","gbt4":"SFP8",\
"gbt5":"SFP9","gbt6":"SFP10","gbt7":"SFP11","gbt8":"SFP12",\
"gbt13":"SFP3","gbt14":"SFP4" }      
    else:
      self.fwinfo= None
    #print "ipbuswrap.py Board:",self.fwinfo
  def getHW(self):
    """
    Needed for atlas spi
    """
    return self.hw
  def scannode(self, parentname, ixnod):
    # ixnod: start processing from self.idslist[ixnod]
    # rc: index to idslist pointing after 'last processed item'
    DBGLIST= False
    while ixnod < len(self.idslist):
      name= self.idslist[ixnod]
      nod= self.hw.getNode(name)
      mode= nod.getMode()
      descr= nod.getDescription()
      if str(mode)=='HIERARCHICAL':
        if DBGLIST:
          print "HIERARCHICAL: %s %s:"%(name, nod), descr
        self.nodlist[name]= nod
        self.level=+ 1
        ixnod= self.scannode(name, ixnod+1)   # pointing after last processed item
      else:
        if name.startswith(parentname):
          if str(mode)=="INCREMENTAL":
            dims= "[%d]"%nod.getSize()
            if DBGLIST:
              print " "*self.level + "%s %s %s:"%(mode, name, str(nod)+dims), descr
          else:
            if DBGLIST:
              print " "*self.level + "%s %s %s:"%(mode, name, nod), descr
          self.nodlist[name]= nod
        else:
          self.level=- 1
          break
        ixnod += 1
    return ixnod   # end of list reached
  def getNodeNames(self, nodename=""):
    """ 
    nodename: "" -return list of top node names
    """
    rc=[]
    for nodname in self.nodlist.keys():
      nnsplit= string.split(nodname,".")
      if nodename:
        if len(nnsplit) == 2:
          if nnsplit[0] == nodename:
            rc.append(nnsplit[1])
      else:
        if len(nnsplit) == 1:
            rc.append(nnsplit[0])
    if nodename:
      if len(rc)>0:
        self.tn_inuse=nodename
    else:
      self.tn_inuse=""
    return rc
  def nodExists(self,nname,topnode=False):
    if self.nodlist.has_key(nname):
      mode= self.nodlist[nname].getMode()
      #print "nodExists %s mode:%s: type:"%(nname, mode), type(mode)
      if topnode:
        if str(mode) == "HIERARCHICAL":
          return True
        else:
          return False
      else:
        return True
    else:
      return False
  def applyTN(self, name):
    pref= ""
    if self.tn_inuse != "":
      names= string.split(name,".")
      #if (len(names) > 1) and ( self.tn_inuse != names[0]):
      if len(names) == 1:
        # apply correction only for single names
        pref= self.tn_inuse+"."
    return pref+name
  def mydispatch(self):
      if self.dispisin: self.hw.dispatch()
  def dispatch(self):
      self.hw.dispatch()
  def Read(self,name, offset=None):
    regname= self.applyTN(name)
    if offset==None:
      register= self.nodlist[regname].read()
      self.mydispatch()
      readval= register.value()
    else:
      block= self.nodlist[regname].readBlockOffset(1,offset)
      self.mydispatch()
      readval= block[0]
    return readval
  def Write(self,name, value, offset=None):
    self.Write_nd(name,value, offset)
    self.mydispatch()
  def Write_nd(self,name, value, offset=None):
    regname= self.applyTN(name)
    if offset==None:
      self.nodlist[regname].write(value)
    else:
      block= []; block.append(value)
      self.nodlist[regname].writeBlockOffset(block, offset)
  def ReadBlock(self,name,N,offset):
    #print "ReadBlock:", name, N, offset
    block= self.nodlist[self.applyTN(name)].readBlockOffset(N,offset)
    self.mydispatch()
    return block
  def WriteBlock_nd(self,name,block,offset):
    self.nodlist[self.applyTN(name)].writeBlockOffset(block, offset)
  def WriteBlock(self,name,block,offset):
    self.WriteBlock_nd(name,block,offset)
    self.mydispatch()
  def WriteFifo(self,name,block):
    self.nodlist[self.applyTN(name)].writeBlock(block)
    self.hw.dispatch()
  def ReadFifo(self,name,N):
    block= self.nodlist[self.applyTN(name)].readBlock(N)
    self.hw.dispatch()
    return block
  def SetBit(self, name, bitn, offset=None):
    reg= self.Read(name, offset)
    reg= reg | (1<<bitn)
    self.Write(name, reg, offset)
  def ResetBit(self, name, bitn, offset=None):
    reg= self.Read(name, offset)
    reg= reg & (~(1<<bitn))
    self.Write(name, reg, offset)
  def isfiwa(self, fwset):
    fwname= self.fwinfo>>24 # fwver= (self.fwinfo>>8) & 0xffff
    if fwname in fwset: return True
    return False
  def isfiverhe(self, fwmin):   # VERSION higher or equal
    fwver= (self.fwinfo>>8)&0xffff
    if fwver >= fwmin: return True
    return False
def OpenBoard(bname):   # should be replaced by OpenATBoard in atbwrap.py
  if not AllBoards.has_key(bname):
    binstance= Board(bname) ; AllBoards[bname]= binstance
  return AllBoards[bname]
def showblock(name, block, offset, N):
  #print "showblock:", len(block), block
  for ix in range(N):
    readval= block[ix]
    print "%s[%d]: "%(name,offset+ix), hex(readval),"=", readval   #, type(readval)
def LoggingOff():
  uhal.disableLogging()
def Init(phbname=None):
  """ Set global manager  pointing to a connection file with used board(s)
rc: manager (also in global manager)
    None: ipbus init problem
Usage:
1. board defined in alice_cf.xml:
rc= ipbuswrap.Init() ; if rc==None: error...
board= ipbuswrap.OpenBoard(boardname)
Advantage: more boards, only one innstance of Board used for multiple openings

2. board denied in alice_boards.xml (i.e. dynamic .xml file to be created)
rc= ipbuswrap.Init(boarname) ; if rc==None: error...
board= ipbuswrap.Board(boardname)
Note: only one board can be used (dynamic connection file with one entry).
"""
  global manager, ConnectionFN
  if manager: 
    print "ipbuswrap.Init already called..."
    return manager
  #uhal.disableLogging()
  uhal.setLogLevelTo( uhal.LogLevel.WARNING ) # DEBUG INFO NOTICE WARNING ERROR FATAL
  if (phbname=="alice_cf") or (phbname==None):
    atbublaze= os.path.join(os.getenv("CTP3_CONFIG_DIRECTORY"),"alice_cf.xml")
    manager= uhal.ConnectionManager("file://"+atbublaze)
    print "ipbuswrap.Init: using STATIC %s connection file..."%atbublaze
    return manager
  #uhal.setLogLevelFromEnvironment( env_variable_name )
  #
  if phbname:
    # check STATIC definition (old way, i.e. check id=board in ConnectionFN using saxipbus)
    atable= saxipbus.findAddrTable(phbname,ConnectionFN)
    if atable:
      print "Static addr table %s for board %s, taken from connection file:"%(atable, phbname)
      print ConnectionFN
      manager= uhal.ConnectionManager("file://"+ConnectionFN)
      return manager
    #
    # not STATIC, check boardid/fwinfo
    ip= saxipbus.findIP(phbname)
    if not ip:
      print "Board %s not found in %s neither in %s."%(phbname,ConnectionFN, AliceBoards)
      return None
  #
  # check boardid/fwinfo
  manager= uhal.ConnectionManager("file://"+AliceBoards)
  board= Board(phbname)
  boardid=fwinfo=None
  cstat="ctrl."    # to be ctrl only from 5.3.2018
  #if not board.nodExists(cstat+"boardid"):
  #  cstat="ctrl."  
  if board.nodExists(cstat+"boardid"):
    boardid= board.Read(cstat+"boardid") & 0xff
  if board.nodExists(cstat+"fwinfo"):
    if self.bname=="atb_3":
      fwinfo= board.fwinfo
    else:
      fwinfo= board.Read(cstat+"fwinfo"); 
  #print "%s: boardid:%d fwinfo:0x%x"%(board.bname, boardid, fwinfo)
  if (boardid == None) or (fwinfo == None):
    print "Board %s: cannot read %sboardid:"%(phbname,cstat),boardid," or %s fwinfo:"%cstat, fwinfo
    manager= None
    return None
  #
  # create phbname.xml, use fi_numbers.cfg
  fwname= fwinfo>>24 ; fwver= (fwinfo>>8) & 0xffff
  adxml= findat.FindAT(fwname, fwver) # e.g.: 5 1 -> test_logic_v1.xml
  if adxml==None:
    print "Board %s: fwinfo: 0x%x not known (cannot assign an address table)"%(phbname, fwinfo)
    print "Try to add an entry with corresponding .xml reference in %s"%ConnectionFN
    manager= None
    return None
  addrtable= os.path.join(os.getenv("CTP3_CONFIG_DIRECTORY"), adxml)
  # todo: phbname can become a list in future..., not yet now
  phxml="""<connections>
  <connection id="%s" uri="chtcp-2.0://localhost:10203?target=%s:50001" address_table="file://%s"/>
</connections>
""" %(phbname, ip, addrtable)
  cnout= open(phbname+".xml", "w")   # opening in ~/WORK directory
  cnout.write(phxml); cnout.close()
  print "Connection file:", os.path.join(os.getcwd(), (phbname+".xml"))
  print "Address table:", addrtable
  manager= uhal.ConnectionManager("file://"+phbname+".xml")
  return manager
def main():
  #if len(sys.argv) < 2 or (len(sys.argv)==2 and sys.argv[1]=="help"):
  if True:
    print """
Program usage:  see ipbuswrap.Init()

available boards (%s): """%saxipbus.AliceBoards
    print "\n'Dynamic .xml' way:"
    saxipbus.printConnectionFile(True)
    sys.exit()
if __name__ == "__main__":
  main()

