#!/usr/bin/env python
import os,os.path,sys,string,time,atbwrap,metrdb.metrdb,tri_ws
import random
from auxfuns import isinargs,printError
ipbpath= os.getenv("CTP3_ROOT")
p101= os.path.join(ipbpath,"ttcpon","rev101")
if not (p101 in sys.path): sys.path.append(p101)
#from ttcpon_core.ttcpon_alice import (OltMlinkExdsgAlice, Gbt)
from atb.gbt import Gbt
import atb.tdomux as tdomux
import atb.cdcscan as cdcscan
from ttcpon_core.ttcpon_alice import OltMlinkExdsgAlice
from ttcpon_core.ttcpon_exdsg import OnuMlinkExdsgAlice
import ttcpon_board_config.pon_fmc_i2c_program as program_fmc
import ttcpon_board_config.init_onu_fmc as init_onu
#import pdb
class TtcPonNetDummy:
  def __init__(self, logger, netname, server=False, init=""):
    self.netname= netname
    self.logger= logger
    self.logger.info('TtcPonNetDummy %s %s'%(netname,init))
    atbwrap.Init() #ipbuswrap.Init("alice_cf")
    # following vars filled in by readConfig()
    self.oltboard= None # instance of atbwrap.ATBoard -master of ttcpon net(s)
    self.gbts= []
    self.allolts= [None]*9  # list of OLTs [ olt1, None, olt3,...,olt9 ]
    self.allonus= [None]*9  # and corresponding list of ONU lists
    self.onufromctp= None   # is always None (should be deleted )
    self.waserror= False
    self.readConfig(netname)
    if self.waserror: return
    self.awmc= tri_ws.AWMclient(netname)
    if self.awmc.ws: 
      print("AWM for dummy ok")
    else:
      print("AWM for dummy not ok")
    # prepare awm (should be here to reflect .net file i.e. also discareded onus):
    for ixolt in range(len(self.allolts)):
      if sel.allolts[ixolt]==None: continue
      for ixonu in range(len(self.allonus[ixolt])):
        onuaddr= str(self.allonus[ixolt][ixonu].onun)
        self.awmc.update_cfg(oltname, onuaddr, ixonu+1)
    #if server:
    #  self.dbo= metrdb.metrdb.MetrDB(self.netname)
    #else:
    #  self.dbo= None
  def readConfig(self, netname):
    import netfile
    cfgdir= os.getenv("CTP3_CONFIG_DIRECTORY")
    print("readConfig dummy...")
    nf= netfile.NetFile(netname+'.net', self.logger)
    if nf.waserror:
      self.waserror= True
    else:
      self.oltboard= gbtboard= atbwrap.OpenATBoard(nf.masterbn)
      if gbtboard==None:
        self.logger.critical("Master board not available.")
        self.waserror= True
  def measureConfig(self):
    self.logger.info('measureConfig dummy...')
  def Stop(self):
    self.logger.info('Stop dummy, closing awmc...')
    orc= self.awmc.ws_close()
  def measureSlow(self):
    self.logger.info('measureSlow dummy...')
    data= {'tc74':22, 'fpgatemp':44}
    # 2. ttcpon net focus:
    for ixolt in range(len(self.allolts)):
      olt= self.allolts[ixolt]
      if olt==None: continue
      if olt.sfpin==None: continue
      for onu in self.allonus[ixolt]:
        onuaddr= onu.onun
        #print "OLT%d onuaddr:%d"%(olt.getoltn(), onuaddr)
        # try
        #errs= olt.onu_errmon_read(onuaddr)   # ok:1 fecS fecD sc_crc_detected
        if (random.randint(0,100) % 2)==0:
          errs= [1,0,0,0]
        else:
          errs= [1,1,0,0]
        # except return "can't read olt"
        # olt1_1_dsmon:(0,0,0)
        #errseen= olt.onu_errmon_read_seen_error(onuaddr)   # just sticky bit, as above
        keyname= "olt%d_%d_dsmon"%(olt.getoltn(), onuaddr)
        if errs[0]==1:
          data[keyname]= errs[1:]
        else:
          data[keyname]= None
        self.awmc.update(keyname, data[keyname])
        #print "measureSlow:",keyname,":", errs
        # oltX_Y_onu
    self.awmc.sendawm()
    return(None)

class TtcPonNet:
  def __init__(self, logger, netname, server=False, init=""):
    self.netname= netname
    self.logger= logger
    self.logger.info('TtcPonNet %s init:%s'%(netname, init))
    #logging.info('TtcPonNet init '+ netname)
    atbwrap.Init() #ipbuswrap.Init("alice_cf")
    # following vars filled in by readConfig()
    self.oltboard= None # instance of atbwrap.ATBoard -master of ttcpon net(s)
    self.gbts= []
    self.allolts= [None]*9  # list of OLTs
    self.allonus= [None]*9  # and corresponding list of ONU lists
    self.onufromctp= None   # is always None (should be deleted )
    self.waserror= False
    self.readConfig(netname)
    if self.waserror: return
    if len(self.allolts)==0:
      self.logger.critical("No OLT defined in .net file")
      self.waserror= True
    else:
      self.logger.info("OLTs:%d"%len(self.allolts))
    firstolt= self.allolts[0]  ; firstoltn= firstolt.getoltn()
    #if not firstolt.setmux():
    #  self.logger.critical("Cannot set mux for olt%d"%firstoltn)
    #  self.waserror= True
    #  return
    # throw out all olts (but 1st one) without SFPs included:
    self.awmc= tri_ws.AWMclient(netname)
    if self.awmc.ws: 
      print("AWM ok")
    else:
      print("AWM not available")
    olts_todiscard= []   # indexes into self.allolts/self.allonus
    for ixolt in range(len(self.allolts)):
      olt= self.allolts[ixolt]
      if olt==None:continue
      oltname= "olt%d"%olt.getoltn()
      vendor= olt.sfpin
      if vendor==None:
        if firstoltn==1: 
          # OLT1 exception: can exist event without SFP
          self.logger.info("OLT1 allocated always, even without SFP.")
        else:
          olts_todiscard.append(ixolt)
          continue
      # prepare awm (should be here to reflect .net file i.e. also discareded onus):
      for ixonu in range(len(self.allonus[ixolt])):
        onuaddr= str(self.allonus[ixolt][ixonu].onun)
        self.awmc.update_cfg(oltname, onuaddr, ixonu+1)
    print "ttcponnet olts_todiscard:",olts_todiscard
    for ix in range(len(olts_todiscard)-1, -1, -1):
      self.allolts[ix]= None
      self.allonus[ix]= None
    if self.waserror: return
    if init=="init":
      self.initATB()     # init PLL
      self.INIT_OLTS()
    #
    self.masterboard= firstolt.ctrlcon.board
    if server:
      self.dbo= metrdb.metrdb.MetrDB(self.netname)
    else:
      self.dbo= None
  def initATB(self):
    # default pll (atb):
    #olt.ctrlcon.plldev.checkandload("cfg/ok_ltu_logic.hpy")
    # OLT depends on mode:
    msg= None ; fw= olt.ctrlcon.board.fwinfo
    #if olt.ctrlcon.board.isfiwa((olt.ctrlcon.board.FW_LTU_LOGIC,olt.ctrlcon.board.FW_CTP_LOGIC)):
    if fw:
      if ((fw>>24) == 0xb) and ((fw & 0xffffff) < 0x000c00):
        msg= "ATB fw: 0x%x, use ttcpon010 for ATB firmwares < 0xc00"%fw
      elif ((fw>>24) == 0xb) or ((fw>>24) == 0xc):
        pass   # ltu logic or ltu_logic_itsmft
      elif (fw>>24) != 0xa:
        msg= "Not an ctp_logic neither ltu_logic..."
    else:
      msg= "fwinfo: None, is this a ctp or ltu logic ?"
    if msg:
      print
      print msg
      print
      return
    olt.ctrlcon.plldev.checkgs(olt.gsmode, True)   # True:load if not correct
  def INIT_OLTS(self):
    rc= 0 ; msg= ""
    for ixolt in range(len(self.allolts)):
      olt= self.allolts[ixolt]
      if olt==None: continue
      rc1,msg= self.olt1init(olt)
      if rc1 != 0:
        msg= "OLT%d init: %s"%(olt.getoltn(), msg)
    return rc,msg
  def INIT_ONUS(self,olts=None):  # list of OLTs whose ONUs will be initialised
    """ todo:
    rcpa,val= onu.txpa("m")
"""
    rc= 0 ; msg= ""
    if olts==None: olts= self.allolts
    ixoolst= range(len(olts))
    header= False
    for ixoo in ixoolst:
      #print "olt ixoo:", ixoo
      olt= olts[ixoo]
      if olt==None: continue
      onu= self.allonus[ixoo] ; Nonus= len(onu)   # ixoo set
      onulst= range(Nonus)
      for onuix in onulst:
        #print "------ OLT%d ONU%d:"%(ixoo+1, onuix+1)
        onun= onuix+1
        onu1= onu[onun-1]
        onu_addr= onu1.onun
        if onu1.ctrlcon==None:
          print "cannot do for ONU%d -CRU"%onun
          continue
        onu_name= onu1.ctrlcon.board.bname[4:]
        # init:
        if onu1.monionu:
          pload= False
          print "PLL not checked/loaded for monitoring ONU."
        else:
          pload= True
        if onu1.monionu and (onuix>0):
          print "onu * init NOT DONE for monitoring ONU (must by done first, followed by 'olt reset')"
          rc= 8
        else:
          onu1.setmux()
          onu1.equalizer_adapt()    # should be done only once, after power up
          init_onu.onu_init(onu1, pllload=pload)
          if onu1.olt2ndlevel:   # only if ATB in role of LTU
            print "LTU role, CDC scan, driven by OLT in ", olt.name
            fwinfo= onu1.olt2ndlevel.ctrlcon.board.fwinfo
            #print "olt2ndlevel fwinfo:",hex(fwinfo)
            if ((fwinfo>>8)&0xffff)>=0x11:
              print "fi ver >=11, i.e. cdc scan instead of onu2olt..."
              tdomx= tdomux.TDOmux(onu1.olt2ndlevel.ctrlcon.board)
              cdc= cdcscan.CDC(onu1.olt2ndlevel.ctrlcon.board, tdomx)
              cdcphase= cdc.measure(100)
              if cdcphase==None:
                auxfuns.printError("Cannot measure CDC phase")
              else:
                cdc.setphase(cdcphase)
            else:
              rcapg= init_onu_cascaded.automatic_phase_good_onu2olt(onu1,
                onu1.olt2ndlevel)
              print "[locked,phase_good_onu2olt]:",rcapg
          elif onu1.monionu:
            print "MONONU,no CDC scan"
          else:
            print "CRU role, no CDC scan, driven by OLT in ", olt.name
          onu1.txpa("m")
    return rc,msg
  def allonuadds(self, ixolt, onlyvalid=False):
    """rc: list of all onu addreses """
    listonus= []
    #olt= olts[ixolt]
    onu= self.allonus[ixolt] ; Nonus= len(onu)
    for ixonun in range(Nonus):
      if onlyvalid and onu[ixonun-1].excluded():
        pass
      else:
        listonus.append(onu[ixonun].onun)
    return listonus

  def FULLCAL(self, olts=None):
    """ olts: list of OLT numbers-1 [0,3,...]
rc: 0 ok
4 calib not successfull for some OLT(s)
8 error 
"""
    rc= 0 ; msg= ""
    if olts==None: olts= self.allolts
    ixoolst= range(len(olts))
    header= False
    for ixoo in ixoolst:
      #print "olt ixoo:", ixoo
        olt= olts[ixoo]
        if olt==None: continue
        oltonus= self.allonus[ixoo]
        # System Init - Full
        # List of ONU addresses expected to be in the system
        onulist= self.allonuadds(ixoo, onlyvalid=True)
        print "fullcal for ONUs:", onulist, " in:", olt.name+'_olt_config'
        olt.setmux()
        print "oltreset NOT DONE before the start of fullcal"
        #olt.oltreset()   # may fix 'No position found for SFP_RX_RESET' 
        #                   but shakes ONUs for cca 3 secs!
        onu_list = olt.full_calibration_run(onulist)
        if onu_list==None:
          print "fullcal abandoned, no onus..."
          continue
        #print "fullcal:",len(onu_list), onu_list
        detected= []
        for ix in range(len(onu_list)):
          if onu_list[ix]['detected']==1:
            detected.append(onu_list[ix]['onu_addr'])
        msg= "fullcal at %s.%d fwinfo:0x%x, %d ONUs(out of %d) detected:%s"%\
          (olt.name, olt.getoltn(), olt.ctrlcon.board.fwinfo, len(detected),\
          len(onulist), str(detected))
        if len(onulist) != len(detected): rc= 4
        self.logger.info(msg)
        print msg
        csvname= olt.getoltcsvn()
        olt.save_onu_config_csv(onu_list,"onu"+csvname)
        olt.save_olt_config_csv("olt"+csvname)
        print "[olt|onu]"+csvname+" config files saved."
        print "Clearing sticky bits..."
        for ix in range(len(oltonus)):
          if oltonus[ix].onun in ['detected']==1:
            olt.onu_errmon_clear(oltonus[ix].onun)
        olt.phymon_clear()
        olt.errmon_clear() 
        for ix in range(len(oltonus)):
          if oltonus[ix].onun in detected:
            olt.onu_phymon_clear(oltonus[ix].onun)
        print "Clearing flags on olt..."
        olt.clear_olt_monitor_status()   # olt part
        print "ONUs flags not cleared..."   # seems bug in 
        continue                            #olt.clear_onu_monitor_status(onu_addr)
        # todo
        for onuix in range(len(oltonus)):    # onus part
          onu_addr= oltonus[onuix].onun
          if oltonus[onuix].excluded():
            print "  Skipping excluded ONU%d addr%d."%(onuix+1, onu_addr)
            continue
          muxes= oltonus[onuix].mux
          if muxes:
            print "seti2cmainttcmux(10) on onu%d..."%(onuix+1)
            oltonus[onuix].seti2cmainttcmux(10)   # 10:onu -has to be made here over ipbus!
            print "set_remotemux on onu%d:"%(onuix+1), muxes
            rc= olt.set_remotemux(onu_addr, muxes)   # atb or KC
          else:
            rc= True   # CRU
          if rc:
            print "Clearing flags on onu%d (over olt)..."%(onuix+1)
            olt.clear_onu_monitor_status(onu_addr)
          else:
            msg2= "Error:mux not set?"
            print msg2
            msg= msg+", "+msg2
    return rc,msg
  def HEALTH(self, olts=None):
    rc= 0 ; msg=" todo a health message..."
    if olts==None: olts= self.allolts
    ixoolst= range(len(olts))
    for ixoo in ixoolst:
      #print "olt ixoo:", ixoo
      olt= olts[ixoo]
      if olt==None: continue
      oltonus= self.allonus[ixoo]
      onulist= self.allonuadds(ixoo, onlyvalid=True)
      if len(onulist)==0:
          print("No ONUs...")
          continue
      csvname= "onu"+olt.getoltcsvn()
      # Health check blocks user upstream transmission for a while, to get
      # fresh prbs7_errors/locked values for each onu
      onu_list = olt.read_onu_config_csv(csvname)
      #print "health onu_list (in %s):"%csvname,onu_list
      onu_list_updated = olt.network_health_check(onu_list)
      #print "health onu_list_u (now, prbs7_errors/locked fields updated):",onu_list_updated
    return rc,msg
  def olt1init(self, olt, cdcreset=True):
    """ rc: (0, msg) -ok, (1, errmsg) -error
    """
    rc= 0 ; msg=""
    if olt.sfpin==None:
      printError("OLT module not plugged in")
    olt.config_fine_phase_measurement(0,63,0)      # disable
    #print "olt.config_fine_phase_measurement disabled."
    if False:   #onufromctp:
      onus= onufromctp.getonustatus()
      print "ONUfromctp status: 0x%x (0x25: mgt_rx_ready rx_locked rx40_locked)"%onus   #dir(onufromctp)
      #enable= 0
      #if olt.gsmode=='s': enable= 1
      if (onus & 0x25)==0x25:   # mgt_rx_ready rx_locked rx40_locked
        print """ONUfromctp: equalizer adaptation skipped
    -was/should be done in superior net
"""
        #equalizer_adapt(onufromctp)
      else:   # not connected or problem
        print "ONUfromctp not ok."   #, equalizer adaptation skipped.
    else:
      print "ONUfromctp not present (ok, standalone mode)."
    rcpa= olt.oltreset()
    if (rcpa!=0) and (rc==0): msg="olt reset timeout"
    rc= rc+ rcpa
    olt.setmux()
    program_fmc.monitor_sfp(olt,1)
    rcpa,val= olt.txpa("m")
    if (rcpa!=0) and (rc==0): msg="txpa problem"
    rc= rc+ rcpa
    rcpa,val= olt.rxpa("m")
    if (rcpa!=0) and (rc==0): msg="rxpa problem"
    rc= rc+ rcpa
    olt.setmux(ipbusaccess=True)   # set back to its default state
    # tick destroyed always by 'olt reset'. cdc reset get it correct.
    # todo: implement it in 'olt reset' (now implemented only here in 'olt init')
    if cdcreset:
      tdomx= tdomux.TDOmux(olt.ctrlcon.board)
      cdc= cdcscan.CDC(olt.ctrlcon.board, tdomx)
      cdc.reset()
      print "CDC reset done"
    return rc,msg
  def Stop(self):
    self.logger.info('Stop, closing awmc and db...')
    orc= self.awmc.ws_close()
    self.dbo.Stop()
  def getsfpid(self, f2call, sfpname):
    sfpprop= f2call()   # returned: [rc, property_string]
    if sfpprop[0]==0:
      self.logger.error("%s: vendor or part/serial number cannot be read."%sfpname)
      return None
    else:
      return sfpprop[1]
  def measureConfig(self):
    """ Should be invoked only once, in time of ltud start.
"""
    cfgdata= {}
    olt= None
    print "measureConfig olts:",len(self.allolts)
    for ixolt in range(len(self.allolts)):
      oltdef= self.allolts[ixolt]
      if oltdef==None: continue
      olt= oltdef
      oltname= "olt%d"%olt.getoltn()
      vendor= olt.sfpin
      if vendor==None: continue   # olt not in
      # oltserN:"model,partnum,sernum" oltN:[atb:Addr,Addr,...] onusersN:["a,b,c",...]
      # the same # of items in oltN onusersN
      if not olt.setmux(): continue
      partnum= self.getsfpid(olt.get_sfp_part_number, oltname)
      if partnum==None:
        partnum="?"
      sernum= self.getsfpid(olt.get_sfp_serial_number, oltname)
      if sernum==None:
        sertnum="?"
      serial="%s,%s,%s"%(vendor, partnum, sernum)
      cfgdata["oltser%d"%olt.getoltn()]= serial
      #
      onus= [] ; onusers= []
      for onu in self.allonus[ixolt]:
        onuaddr= onu.onun
        onus.append("%s:%d"%(onu.name, onuaddr))
        print
        if onu.name[:3]=="atb":
          # We should not use ipbus for onus...
          # But this is a spec. case (CRU mimicked by atb) -
          # the address of this ONU has to be set over ipbus
          # see maina.py 'onu vendor N'
          muxes= onu.mux
          onu.seti2cmainttcmux("onu")   # 10:onu -has to be made here over ipbus!
          # at least 1s needed for nonmon ONU! and 2s for mon ONU!
          if onu.monionu:
            tx_mon= "MONONU"
            waits= 2
          else:
            tx_mon= "ONU"
            waits= 1
          print "Setting %s address %d for on ATB/%s board"%(tx_mon, onuaddr, oltname)
          time.sleep(waits)   # at least 1s needed for nonmon ONU! and 2s for mon ONU!
          rc= olt.set_remotemux(onuaddr, muxes)   # atb
        else: # CRU: muxes can not be set
          rc= True
        if rc:
          #print(olt.onu_get_sfp_vendor(onuaddr)[1],\
          serial= "%s,%s,%s"%(olt.onu_get_sfp_vendor(onuaddr)[1],\
            olt.onu_get_sfp_part_number(onuaddr)[1],\
            olt.onu_get_sfp_serial_number(onuaddr)[1])
        else:
          serial= "?,?,?"
        # here we should set remotemuxes to default state if it exist.
        #rc= olt.set_remotemux(onuaddr, deafult_muxes)   # atb
        onu.seti2cmainttcmux("ipbus") # 11:ipbus -set it back to the default state
        onusers.append(serial)
      cfgdata["onusers%d"%olt.getoltn()]= onusers   # ONU serials: list of [vendor,partN,serN]
      cfgdata[oltname]= onus
    olt.setmux(ipbusaccess=True)   # default state also for a master board with OLTs
    print "measureConfig gbts:",len(self.gbts)
    for ixgbt in range(len(self.gbts)):
      gbt= self.gbts[ixgbt]
      gbtname= gbt.slave
      print gbtname, gbt.ok
      vendor= olt.sfpin
      #if vendor==None: continue   # olt not in
      #if not olt.setmux(): continue
      #partnum= self.getsfpid(olt.get_sfp_part_number, oltname)
      #if partnum==None:
      #  partnum="?"
      #sernum= self.getsfpid(olt.get_sfp_serial_number, oltname)
      #if sernum==None:
      #  sertnum="?"
      #serial="%s,%s,%s"%(vendor, partnum, sernum)
      #cfgdata["gbtser%d"%gbt.gbtn]= serial
      #
    print "ttcponnet dbo update:"
    self.dbo.Update(time.time(), cfgdata)
    print "ttcponnet dbo updated"
  def measureSlow(self):
    """ Operation:
    1. read 'slow' values 
    2. update DB with measured values
    rc: None: ok
        "error message"
    olt(temps vols alarms...) onu1(...) onu2(...) ...
    onuX: 2 cases: 
          ltud: values acquired over fibre (ttcpon SLC)
          ctpd: values over:
             A) ipbus 
             B) interprocess communication (grpc) from ltud?  or
             C) SLC? 
             Seems B) is least 'critical section locking' 
    """
    #fpgatemp= self.masterboard.ltudevs["fpga"].gettemp()
    #print "fpgatemp:", fpgatemp
    # 1. read OLT + net values as quickly as possible
    # OLT board focus (returnes also timestamp):
    rc= None
    errmsg,tsvals= self.masterboard.getSlow()
    if errmsg!="":
      self.logger.error(errmsg)
    #print "bname:",self.masterboard.bname, tsvals
    data= {'tc74':tsvals[1], 'fpgatemp':tsvals[2]}
    # 2A. ttcpon net focus OLTs:
    for ixolt in range(len(self.allolts)):
      olt= self.allolts[ixolt]
      if olt==None: continue
      if olt.sfpin==None: continue
      for onu in self.allonus[ixolt]:
        onuaddr= onu.onun
        #print "OLT%d onuaddr:%d"%(olt.getoltn(), onuaddr)
        # try
        errs= olt.onu_errmon_read(onuaddr)   # ok:1 fecS fecD sc_crc_detected
        # except return "can't read olt"
        # olt1_1_dsmon:(0,0,0)
        #errseen= olt.onu_errmon_read_seen_error(onuaddr)   # just sticky bit, as above
        keyname= "olt%d_%d_dsmon"%(olt.getoltn(), onuaddr)
        if errs[0]==1:
          data[keyname]= errs[1:]
        else:
          data[keyname]= None
        self.awmc.update(keyname, data[keyname])
        #print "measureSlow:",keyname,":", errs
        # oltX_Y_onu
    # 2B. ttcpon net focus GBTs:
    #for ixgbt in range(len(self.gbts)):    todo: over SFPs (or add SFP in Gbt class)
    divajses=self.masterboard.findDeviceSFPS()
    sfpnames= ""
    for ix in range(len(divajses)):
      sfpnames= sfpnames+" "+divajses[ix].devname+":"+str(divajses[ix].gettemp())
    print "ttcponnet sfpnames:", sfpnames
    # ttcponnet sfpnames:  SFP2 SFP7 SFP6 SFP5 SFP12 SFP1
    # 
    self.awmc.sendawm()
    # 3. update DB
    rc= self.dbo.UpdateSmooth(tsvals[0], data) # update db
    return rc
  def readConfig(self, netname):
    """
"""
    cfgdir= os.getenv("CTP3_CONFIG_DIRECTORY")
    fpath= os.path.join(cfgdir,"nets", netname+".net")
    if not os.path.exists(fpath):
      self.logger.critical("%s does not exist",fpath)
      self.waserror= True
      return
    linen= -1
    fd= open(fpath,"r") ; netcfg= fd.readlines() ; fd.close()
    for ixl in range(len(netcfg)):
      line= string.split(string.strip(netcfg[ixl]))
      if netcfg[ixl][0]=='#': continue
      if len(line)==0: continue
      if linen==-1:    # 1st line of netcfg
        #----------------------------------------------------- # 1st line of netcfg
        oltonuboard= line[0] 
        maxgbtn=14 
        self.oltboard= gbtboard= atbwrap.OpenATBoard(oltonuboard)
        if gbtboard==None:
          self.logger.critical("Master board not available.")
          self.waserror= True
          return
        linen= 0
        oltmode= 's'
        oltmodetx= 'standalone'
        if (len(line) > 1) and ((line[1]=='g') or (line[1]=="global")): 
          oltmode= 'g'
          oltmodetx= 'global'
          # special onu instance. -1: do not touch onu address when instantiating
          # needs to be instantiated even without ONU SFP (exd_freeze_cdr_test_mode) ?
          # Let's instantiate only in global mode!
          #
          #  onufromctp abandoned, from 26.6.2019: there is a spec. instance of OLT1
          #  for each onu in superior net
          # for each ONU on ATB board regardless of:
          # - ATB is in role of CRU (debugging ie OLT physically does not have to be present) or
          # - ATB in role of LTU
          # self.onufromctp= OnuMlinkExdsgAlice(oltonuboard, '', -1, False)
        continue
      if (len(line[0])>3) and (line[0].find("gbt")==0):   # gbt line
        #----------------------------------------------------- GBT line
        #print "gbt line", line
        try:
          gslot= int(line[0][3:])
        except:
          self.logger.critical("Error: in .net: %s",netcfg[ixl])
          self.waserror= True
          continue
        if gslot > maxgbtn:
          self.logger.critical("Error too high gbt nmuber (max:%d): %s",\
            (maxgbtn,netcfg[ixl]))
          continue
        #for ixg in range(2, len(line)):   # remove comment at the end of line
        gbtname= "gbt%d"%gslot
        if gbtboard.nodExists(gbtname):
          alreadyin= False
          for ixgbts in range(len(self.gbts)):
            if self.gbts[ixgbts].slave == gbtname:
              print "Error: %s already defined in .net file"%gbtname
              alreadyin= True
              break
          if alreadyin: continue
        if (len(line)<2) or ((line[1]!="vtrx") and (line[1]!="sfp") and (line[1]!="sfpbsr")):
          print "Error in .net (gbtN expected with vtrx sfp or sfpbsr):",\
            netcfg[ixl]
          continue
        #self.gbts.append(Gbt(gbtboard.i2cg, gslot, line[1]))
        # instead, find corresponding SFP instance pointing to Gbt instance
        if gbtname in gbtboard.fwsfps:   # todo: FSFPs not considered  yet
          sfp= gbtboard.findDevice(gbtboard.fwsfps[gbtname])
          if sfp!= None:
            sfp.purpose.initdest(line[1])   # vtrx sfp sfpbsr
            self.gbts.append(sfp.purpose)
        continue
      #----------------------------------------------------- OLT line
      lane= int(line[0])-1   # lane: an olt slot: 0..8 corresponding to olt1..olt9
      solt= "olt%d"%(lane+1)
      if not gbtboard.fwsfps.has_key(solt):
        print "Error: OLT%d not allowed, ignoring line: %s"%((lane+1),netcfg[ixl])
        continue
      olt= OltMlinkExdsgAlice(oltonuboard, '', lane=lane, mode= oltmode,\
        logger= self.logger)
      self.allolts[lane]= olt
      self.allonus[lane]= []   # each OLT line accompanied by a list of ONUs
      self.logger.info("OLT%d: %s %s"%((lane+1), olt.ctrlcon.board.bname, oltmodetx))
      if isinargs("pllcheck"): 
        olt.ctrlcon.plldev.checkgs(oltmode, load=True)
      onus= self.allonus[lane]
      onusnames={}   # check if ONU already defined in an OLT line
      onuadds=[]    # check the uniqueness of an ONU address in an OLT line
      # todo: check if atb appeared in multiple OLT lines...
      for idaix in range(len(line[1:])):   # start after "OLTN", 1st item in the line followed by fed onus
        ida= line[1+idaix]    # atb_10 atbp_7 atb_8:20 20 kc:1 kcu:4
        if onusnames.has_key(ida) and (onusnames[ida]==True):
          print "Warning: %s ignored (given already in the same line)"%(ida)
          continue 
        #if type(ida) is int:   # CRU
        self.logger.info("  %s..."%ida)
        if (ida[0]>'0') and (ida[0]<='9'):   # CRU
          onuadd= int(ida)
          onus.append(OnuMlinkExdsgAlice('', '', onuadd))
          print "ONU%d: CRU:%s"%(len(onus), ida)
        elif ida[:4]=="atb_" or ida[:5]=="atbp_":   # atb, take address of the board for ONUaddr or atb_N:addr
          ida01= string.split(ida,":")
          # default: atb in role of LTU. 
          # If 3rd param added (eg: atb_11:7:cru), ol2ndlevel is not allocated,
          # i.e. onu2olt good phase NOT done)
          ida0= ida01[0]
          print "ttcponnet ida0:",ida0
          if ida0[:4]=="atb_":       # let's take atb number for ONU addr
            onuadd= int(ida0[4:])
          else:
            onuadd= int(ida0[5:])
          if len(ida01)>=2:          # atb_20:7
            if ida01[1]!="":
              onuadd= int(ida01[1])   # explicitly defined, i.e. atb_20:7
          #pdb.set_trace()
          if onuadd in onuadds:
            print "Error: ONU address %d already used in the same .net line"%onuadd
            self.waserror= True
            continue
          if ida0 == oltonuboard:
            # monitoring ONU special: GOOD_PHASE first, and do not load PLL (loaded for OLT already)!
            if idaix==0: 
              if oltmode=='g':
                printError("Error: monitoring ONU %s allowed only in stdalone mode."%ida)
                self.waserror= True ; return
              # check if fp clock connected for mononu:
              olt.ctrlcon.plldev.clearSticky()
              rc,msg= olt.ctrlcon.plldev.cclosl()
              if rc==0:
                print msg
                mononu= True
                mononutx= "Monitoring ONU, connected to "+solt.upper()+'.'
              else:
                print msg
                printError("Error: monitoring ONU %s needs external clock (Front Panel BC IN)."%ida)
                self.waserror= True ; return
            else: 
              printError("Error: monitoring ONU %s has to be 1st one in the list of ONUs."%ida)
              self.waserror= True ; return
          else:
            mononu= False
            mononutx= ""
          print "ttcponnet pllcheck:",ida0
          if isinargs("pllcheck"):    # check pll config for all atb ONUs
            if mononu:   
              # PLLcfg has to be 'stdalone', but possible load is left to be done in OLT part
              onus[-1].ctrlcon.plldev.checkgs('s', False, True)
            else:
              # PLLcfg has to be 'global', let's load it if not required cfg:
              onus[-1].ctrlcon.plldev.checkgs('g', True, True)
          # add 1 special olt instance for onu2olt phase. Not needed if ATB in CRU role,
          # but allocated anyhow: it is differentiated in .net file by using:
          # atb_24:cru  -for atb_24 in role of CRU
          # atb_24      -for atb_24 in role of LTU  (default -normally, atb boards are in LTU role!)
          # if roleCRU: olt2ndlevel= None
          if mononu:
            olt2ndlevel= None   # cannot come from CTP if connected as monitoring
          elif (len(ida01)==3):
            if (ida01[2]!='CRU') and (ida01[2]!='cru'):
              print "Error: cru or CRU expected, (not %s). %s role: LTU"%(ida01[0],ida01[2])
              olt2ndlevel= True
            else:
              olt2ndlevel= None
          else:
            olt2ndlevel= True
          if olt2ndlevel==True:
            olt2ndlevel= OltMlinkExdsgAlice(ida0, '', lane=0, mode= 'g', logger=self.logger) # lane: 0 corresponds to olt1
            #the ATB board in LTU role: FP clock must be connected
            #olt.ctrlcon.plldev.clearSticky()
            print "ttcponnet cclosl:",ida0
            rc,msg= olt2ndlevel.ctrlcon.plldev.cclosl()
            if rc==0:
              ltu2msg= "LTU %s:"%ida0+msg
              print ltu2msg
            else:
              ltu2msg= "LTU %s cannot be driven by CTP:"%ida0+msg
              print ltu2msg
              self.waserror= True ; return
          onus.append(OnuMlinkExdsgAlice(ida0, '', onuadd, mononu,olt2ndlevel))
          print "ONU%d: %s"%(len(onus), ida), mononutx
        elif ida[:2]=="kc" or ida[:3]=="kcu":   #
          if ida=="kcu":
            onus.append(OnuMlinkExdsgAlice('192.168.1.19', 9001, 4))   # v010
            onuadd= 4
          else:
            onus.append(OnuMlinkExdsgAlice('192.168.1.11', 9001, 1))   # v010
            onuadd= 1
          print "ONU%d: %s onuadd:%d"%(len(onus), ida, onuadd), mononutx
        else:
          print "Error: bad ONU: %s in .net file"%ida
          self.waserror= True
        onusnames[ida]= True
        onuadds.append(onuadd)
    # .net processed
